debug(L):- opt(debug),!,writelist(L).
debug(_).

debugln(L):- opt(debug),!,writelist(L),nl.
debugln(_).

debug_expr_ln(E):- opt(debug),!,pretty_expr(E,F),write(F),nl.
debug_expr_ln(_).

pretty_expr(E,F):- map_subterms(get_groundattr,[r/2],E,F).

pretty_fact(C=DV,A=V):- 
	get_groundattr(r(0,C),A),
	( DV=[], !, V=[null]; DV=[V]).
	
get_groundattr(r(I,C),T):-
	groundattr(C,X/N,Args),
	functor(T0,X,N),
	get_groundattr_args(N,T0,Args),
	(I=0,!,T=T0; 
	 I='g',!,T='goal.' T0;
	 K is -I, prevtimes(K,T0,T)
	).	
	
get_groundattr_args(0,_,_):-!.
get_groundattr_args(N,T,As):-
	nth1(N,As,A),arg(N,T,A),M is N-1,get_groundattr_args(M,T,As).

prevtimes(0,T,T):-!.
prevtimes(N,T0,'prev.' T):-
	M is N-1, prevtimes(M,T0,T).
